unit NWInfo;

{
  Interface Unit for NWInfo.dll

  Description

  This interface unit simply imports the one function exported by NWInfo.DLL:

  The DLLs are written in Delphi, but can be called from any
  programming language that can call external DLLs,
  e.g., VB, VC, Delphi 2,3,4, PowerBuilder, ...

  For syntax details, see NWINFO.DPR

  To make access from Delphi easier, this simple import unit NWInfo.PAS has
  been added.
  Instead of explicitly importing the DLL function, simply add NWInfo to your
  'uses ...' statement.

  For demonstration purposes two basic test applications have been included:
      NWTest      Call some error messages from NWInfo.DLL
}


interface

{$I NWTypes.inc}

Function NWInitialize               : NWCCODE;                             {$IFDEF Win32} stdcall; {$ENDIF}
{        Sample call:  if NWInitialize<>0 then ShowMessage('NetWare Client not installed');  }

Function NWGetInfo(Drv: Byte; InfoType: Byte; Info: Pointer): NWCCODE;     {$IFDEF Win32} stdcall; {$ENDIF}
{        Sample call:  cCode := NWGetInfo(6, $26, @Info)
                       if cCode=0 then ShowMessage('My NDS Name is '+StrPas(Info));  }

implementation

Function NWInitialize;   external  'NWINFO.DLL' index 1;
Function NWGetInfo;      external  'NWINFO.DLL' index 2;

end.
 