unit NWTest_U;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ComboBoxDrv: TComboBox;
    Memo1: TMemo;
    ComboBoxInfoType: TComboBox;
    Button3: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function  GetThatInfo(drv, InfoType: Byte): String;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure EnableButtons(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses NWInfo;


procedure TForm1.FormCreate(Sender: TObject);
          // fill the drive combo box with drive letters A:-Z:
VAR
   Drv : Char;
begin
   ComboBoxDrv.Items.Add('Current');
   For Drv := 'A' to 'Z' do ComboBoxDrv.Items.Add(Drv+':');
   ComboBoxInfoType.ItemIndex := 0;
end;

procedure TForm1.Button1Click(Sender: TObject);
          // Test: is the Client32 installed ?
Var
   cCode : NWCCODE;
begin
   cCode := NWInitialize;
   if cCode=0
      then ShowMessage('Loaded')
      else ShowMessage(Format('Not Loaded (error code %04X)', [cCode]));
end;

function TForm1.GetThatInfo(drv, InfoType: Byte): String;
         // Get one info by calling the NWGetInfo function
CONST
   MaxDataSize = $FF;
Var
   Data     : Array[1..MaxDataSize] of char;
   DataInt  : nuint32      absolute Data;
   DataVer  : TNWCCVersion absolute Data;
   cCode    : NWCCODE;
begin
   Screen.Cursor := crHourglass;
   Application.ProcessMessages;
   cCode := NWGetInfo(drv, InfoType, @Data);
       if (cCode<>0)
          then result := Format('Error %04X', [cCode])
          else case InfoType of   // some are integers, some are strings
               0..5, $14, $17, $21..$2A:          result := StrPas(@Data);
               6,7, $11..$13, $15, $16, $18..$1B: result := Format('%08X',  [DataInt]);
               $1C:                               result := Format('%d.%d', [DataVer.major, DataVer.minor]);
               end;
   result := Format('%02X:  %s', [InfoType, result]);
   Screen.Cursor := crDefault;
end;

procedure TForm1.Button2Click(Sender: TObject);
          // Get the info that was selected
begin
   Memo1.Clear;
   Memo1.Lines.Add(GetThatInfo(ComboBoxDrv.Itemindex, ComboBoxInfoType.ItemIndex));
end;

procedure TForm1.Button3Click(Sender: TObject);
          // Get all available info
Var
   i        : Integer;
begin
   ListBox1.Clear;
   if ComboBoxDrv.Text='' then exit;
   for i := 0 to $2A do try
       Listbox1.Items.Add(GetThatInfo(ComboBoxDrv.Itemindex, i));
       except
          On E:Exception do
             Listbox1.Items.Add(Format('%02X:  %s',   [i, E.Message]));
       end;
end;

procedure TForm1.EnableButtons(Sender: TObject);
begin     // enable or disable buttons
   Button2.Enabled := (ComboBoxDrv.ItemIndex<>-1) and (ComboBoxInfoType.ItemIndex<>-1);
   Button3.Enabled := (ComboBoxDrv.ItemIndex<>-1);
end;

procedure TForm1.FormResize(Sender: TObject);
CONST Border = 15;
begin     // cosmetic: adjust control size to form size
   Button1.Width  := Form1.ClientWidth - 2*Border;
   Button2.Width  := Button1.Width;
   Button3.Width  := Button1.Width;
   Memo1.Width    := Button1.Width;
   ListBox1.Width := Button1.Width;
   ListBox1.Height        := Form1.ClientHeight - ListBox1.Top          - Border;
   ComboBoxInfoType.Width := Form1.ClientWidth  - ComboBoxInfoType.Left - Border;
end;

end.
