{$IFNDEF NWTYPES}
{$DEFINE NWTYPES}

// these types are also declared in the NetWare NDK units for Delphi 

CONST
   CALWIN      = 'CALWIN32.DLL';
   CLXWIN      = 'CLXWIN32.DLL';
   NETWIN      = 'NETWIN32.DLL';

   N_FALSE                 = 0;
   N_TRUE                  = 1;

   NWCC_NDS_NOT_CAPABLE    = 0;
   NWCC_NDS_CAPABLE        = 1;
   
   DCV_TYPELESS_NAMES      = $04;  // default: not set
   DCV_CANONICALIZE_NAMES  = $10;  // default: set

   MaxDataSize = $3FF;

TYPE

   pInfo   = ^TInfo;
   pLong   = ^LongInt;

   nint8       = ShortInt;
   nuint8      = Byte;
   nint16      = SmallInt;
   nuint16     = Word;
   nint32      = LongInt;
   nuint32     = LongInt;     (* No unsigned 32-bit type *)
   nreal32     = Single;
   nreal64     = Double;
   nint        = Integer;
   nuint       = Cardinal;
   nbool       = WordBool;
   nreal       = Double;
   nbool8      = Byte;
   nbool16     = Word;
   nbool32     = LongInt;
   nfixed      = nint32;
   nstr8       = char;
   nstr16      = nuint16;
   nstr        = nstr8;
   nchar       = nstr;
   nchar8      = nstr8;
   nchar16     = nstr16;
   nwchar      = nchar16;
   nptr        = Pointer;
   npproc      = Pointer;

   pnint8      = ^nint8;
   pnuint8     = ^nuint8;
   pnint16     = ^nint16;
   pnuint16    = ^nuint16;
   pnint32     = ^nint32;
   pnuint32    = ^nuint32;
   pnint       = ^nint;
   pnuint      = ^nuint;
   pnstr8      = ^nstr8;

   NWCCODE         = nuint;
   NWRCODE         = nint32;

   NWCONN_HANDLE   = nuint;
   pNWCONN_HANDLE  = pnuint;
   NWCONN_NUM      = nuint16;
   NWDIR_HANDLE    = nuint8;

   NWDSContextHandle  = nuint32;
   NWDSCCODE          = Integer;

   TInfo    = Array[0..4096]        of char;
   TNWPath  = Array[1..MaxDataSize] of Char;

   TNWCCVersion = Record
                  major   : nuint;
                  minor   : nuint;
                  revision: nuint;
                  end;

{$ENDIF}
