//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "nwinfo.h"

/*
   The following header files declare some types and constants.
   You will find the headers in the NDK (downloadable from the NDK web site),
   after installation they are in the \NWSDK\include directory
*/

#if ! defined ( NTYPES_H )
#include "ntypes.h"
#endif

#if ! defined ( NWCLXCON_H )
#include "nwclxcon.h"
#endif


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{  // Test: is the Client32 installed ?
   NWCCODE cCode;
   cCode = NWInitialize();
   if (cCode==0)
        ShowMessage("Client 32 is loaded");
        else
        ShowMessage("Error initializing Client32");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{  // fill the drive combo box with drive letters A:-Z:
   for (char drv='A'; drv <= 'Z'; drv++)
       ComboBoxDrv->Items->Add(drv);
   ComboBoxInfoType->ItemIndex = 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EnableButtons(TObject *Sender)
{    // enable buttons if drive and InfoType are selected
   Button2->Enabled = (ComboBoxDrv->ItemIndex != -1) && (ComboBoxInfoType->ItemIndex != -1);
   Button3->Enabled = (ComboBoxDrv->ItemIndex != -1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{    // get only the selected info for the selected drive
   Memo1->Lines->Clear();
   Memo1->Lines->Add(GetThatInfo(ComboBoxDrv->ItemIndex, ComboBoxInfoType->ItemIndex));
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{  // Get all available info
   ListBox1->Clear();
   for (int i=0; i <= 0x2A; i++)
       ListBox1->Items->Add(GetThatInfo(ComboBoxDrv->ItemIndex, i));
}
//---------------------------------------------------------------------------

AnsiString TForm1::GetThatInfo(int drv, int InfoType)
{  // collect the info from NWINFO.DLL and format it for string output
   NWCCODE     cCode;
   AnsiString  result;
   union {
          char         dataC[255];
          NWCCVersion  dataV;
          nuint32      dataInt;
         } data;

   Screen->Cursor = crHourGlass;
   Application->ProcessMessages();
   cCode = NWGetInfo(nuint8(drv), nuint8(InfoType), pnuint8(&data));
   Screen->Cursor = crDefault;
   if (cCode!=0)
        return Format("%02d: Error - %04X", ARRAYOFCONST((InfoType, int(cCode))));
      else
      {
        switch (InfoType)  {
           case 0x1C:
                result = Format("%02d: v %d.%02d", ARRAYOFCONST((InfoType, int(data.dataV.major), int(data.dataV.minor))));
                break;
           case 0x06:
           case 0x07:
           case 0x11:
           case 0x12:
           case 0x13:
           case 0x15:
           case 0x16:
           case 0x18:
           case 0x19:
           case 0x1A:
           case 0x1B:
                result = Format("%02d: %08X", ARRAYOFCONST((InfoType, int(data.dataInt))));
                break;
            default:
                result = Format("%02d: %s", ARRAYOFCONST((InfoType, data.dataC)));
                break;
           }
        return result;
      }
}

void __fastcall TForm1::FormResize(TObject *Sender)
{    // cosmetics for the controls
   Button1->Width          = Form1->ClientWidth - 2*(Button1->Left);
   Button2->Width          = Button1->Width;
   Button3->Width          = Button1->Width;
   Memo1->Width            = Button1->Width;
   ListBox1->Width         = Button1->Width;
   ListBox1->Height        = Panel1->ClientHeight - ListBox1->Top          - Button1->Left;
   ComboBoxInfoType->Width = Panel1->ClientWidth  - ComboBoxInfoType->Left - Button1->Left;
}
//---------------------------------------------------------------------------

